/**
 * Class Book manages the title and author of a book.
 * 
 * @author Prof. Carl B. Struck
 * @version Spring 2010
 */
public class Book
{
    private String title;   // book title as a String
    private String author;  // book’s author as a String


    /**
     * No parameter constructor initializes instance variables to default values.
     */
    public Book()
    {
        this("", "");
    }

    /**
     * Constructor initializes instance variables to the values of the parameters.
     */
    public Book(String title, String author)
    {
        setTitle(title);
        setAuthor(author);
    }
    
    /**
     * Updates value of title instance variables.
     */
    public void setTitle(String title)
    {
        this.title = title;
    }

    /**
     * Updates value of author instance variables.
     */
    public void setAuthor(String author)
    {
        this.author = author;
    }

    /**
     * Returns value of title instance variables.
     */
    public String getTitle()
    {
        return title;
    }

    /**
     * Returns value of author instance variables.
     */
    public String getAuthor()
    {
        return author;
    }
}
